#-------------------------------------------------
#
# Project created by QtCreator 2012-02-21T22:44:17
#
#-------------------------------------------------

QT       += core gui webkit script xml sql

TARGET = QtDennco
TEMPLATE = app


INCLUDEPATH += QtScript platform/qt ../Thirdparty/serialport/include

SOURCES += QtDennco/mainwindow.cpp \
    QtDennco/main.cpp \
    TKUICell.cpp \
    TKReceptor.cpp \
    TKLog.cpp \
    TKLock.cpp \
    TKDebug.cpp \
    TKContainer.cpp \
    TKCellCodeInstance.cpp \
    TKCellCode.cpp \
    TKCell.cpp \
    TKAxonTerminal.cpp \
    TKAxon.cpp \
    DNXMLElement.cpp \
    DNXML.cpp \
    DNUtils.cpp \
    DNTimeKeeper.cpp \
    DNFileList.cpp \
    DNEngine.cpp \
    DNDirectory.cpp \
    DNContainerBuilder.cpp \
    DNAlert.cpp \
    QtScript/dnqscellbase.cpp \
    QtScript/dnqsbasiccell.cpp \
    QtScript/dnqscellcode.cpp \
    QtScript/dnqscellcodeinstance.cpp \
    QtScript/dnqscontainer.cpp \
    platform/qt/qttklockimpl.cpp \
    platform/qt/qtdndirectoryimpl.cpp \
    platform/qt/qtdnalertimpl.cpp \
    platform/qt/qtsimplehttpserverimpl.cpp \
    platform/qt/qtdntimekeeperimpl.cpp \
    platform/qt/qtdnxmlimpl.cpp \
    platform/qt/QtTKConsole.cpp \
    DNGlobal.cpp \
    DNThread.cpp \
    platform/qt/qtdnthreadimpl.cpp \
    QtDennco/dnwebinterface.cpp \
    QtScript/dnqsinputcell.cpp \
    QtScript/dnqsoutputcell.cpp \
    platform/qt/qtdnstorageimpl.cpp \
    DNStorage.cpp \
    QtScript/dnqsbasicstoragecell.cpp \
    DNServerHTTP.cpp \
    DNServerSerialPort.cpp \
    DNSerialPort.cpp \
    platform/qt/qtdnserialportimpl.cpp


HEADERS  += QtDennco/mainwindow.h \
    TKUICell.h \
    TKReceptor.h \
    TKLog.h \
    TKLockImpl.h \
    TKLock.h \
    TKDebug.h \
    TKContainer.h \
    TKConsole.h \
    TKCellCodeInstance.h \
    TKCellCode.h \
    TKCell.h \
    TKAxonTerminal.h \
    TKAxon.h \
    DNXMLImpl.h \
    DNXMLElement.h \
    DNXML.h \
    DNUtils.h \
    DNTimeKeeperImpl.h \
    DNTimeKeeper.h \
    DNFileList.h \
    DNEngine.h \
    DNDirectoryImpl.h \
    DNDirectory.h \
    DNContainerBuilder.h \
    DNAlertImpl.h \
    DNAlert.h \
    dennco.h \
    QtScript/dnqscellbase.h \
    QtScript/dnqsbasiccell.h \
    QtScript/dnqscellcode.h \
    QtScript/dnqscellcodeinstance.h \
    QtScript/dnqscontainer.h \
    versioninfo.h \
    platform/qt/qttklockimpl.h \
    platform/qt/qtdndirectoryimpl.h \
    platform/qt/qtdnalertimpl.h \
    platform/qt/qtsimplehttpserverimpl.h \
    platform/qt/qtdntimekeeperimpl.h \
    platform/qt/qtdnxmlimpl.h \
    DNGlobal.h \
    DNThread.h \
    DNThreadImpl.h \
    platform/qt/qtdnthreadimpl.h \
    QtDennco/dnwebinterface.h \
    QtScript/dnqsinputcell.h \
    QtScript/dnqsoutputcell.h \
    DNStorageImpl.h \
    DNStorage.h \
    platform/qt/qtdnstorageimpl.h \
    QtScript/dnqsbasicstoragecell.h \
    DNServerHTTP.h \
    DNServerSerialPort.h \
    DNServerBase.h \
    DNSerialPort.h \
    DNSerialPortImpl.h \
    platform/qt/qtdnserialportimpl.h \
    DNServerHTTPImpl.h

FORMS    += QtDennco/mainwindow.ui
FORMS    += QtDennco/portinfodialog.ui

Debug:DEFINES+=DEBUG
